/*extern "C" {
  // fixed pregenerated tables (in tables.cpp)
  extern const unsigned char left_yuv[], grad_yuv[], med_yuv[];
  extern const unsigned char left_rgb[], left_decorrelate_rgb[], grad_decorrelate_rgb[];
  extern const unsigned char classic_shift_luma[], classic_shift_chroma[];
  extern const unsigned char classic_add_luma[256], classic_add_chroma[256];

  // tables generated at runtime for compression/decompression
  extern unsigned char encode1_shift[256], encode2_shift[256], encode3_shift[256];
  extern unsigned encode1_add_shifted[256], encode2_add_shifted[256], encode3_add_shifted[256];
  struct DecodeTable {
    unsigned char* table_pointers[32];
    unsigned char table_data[129*25];
  };
  extern DecodeTable decode1, decode2, decode3;
  extern unsigned char decode1_shift[256], decode2_shift[256], decode3_shift[256];
};*/

extern "C" {

unsigned long* __cdecl asm_CompressYUY2(const unsigned char* src, unsigned long* dst, const unsigned char* src_end);
unsigned long* __cdecl asm_CompressYUY2Delta(const unsigned char* src, unsigned long* dst, const unsigned char* src_end);
unsigned long* __cdecl asm_CompressUYVY(const unsigned char* src, unsigned long* dst, const unsigned char* src_end);
unsigned long* __cdecl asm_CompressUYVYDelta(const unsigned char* src, unsigned long* dst, const unsigned char* src_end);

unsigned long* __cdecl asm_CompressRGBDelta(const unsigned char* src, unsigned long* dst, const unsigned char* src_end);
unsigned long* __cdecl asm_CompressRGBDeltaDecorrelate(const unsigned char* src, unsigned long* dst, const unsigned char* src_end);
unsigned long* __cdecl asm_CompressRGBADelta(const unsigned char* src, unsigned long* dst, const unsigned char* src_end);
unsigned long* __cdecl asm_CompressRGBADeltaDecorrelate(const unsigned char* src, unsigned long* dst, const unsigned char* src_end);

void __cdecl mmx_RowDiff(const unsigned char* src, unsigned char* dst, const unsigned char* src_end, int stride);

void __cdecl mmx_RowAccum(unsigned char* buf, unsigned char* buf_end, int stride);

void __cdecl mmx_MedianPredictYUY2(const unsigned char* src, unsigned char* dst, const unsigned char* src_end, int stride);
void __cdecl mmx_MedianPredictUYVY(const unsigned char* src, unsigned char* dst, const unsigned char* src_end, int stride);

void __cdecl asm_MedianRestore(unsigned char* buf, unsigned char* buf_end, int stride);

void __cdecl asm_DecompressHFYU16(const unsigned long* src, unsigned char* dst, unsigned char* dst_end);
void __cdecl asm_DecompressHFYU16Delta(const unsigned long* src, unsigned char* dst, unsigned char* dst_end);

void __cdecl asm_DecompressHFYU24To24Delta(const unsigned long* src, unsigned char* dst, unsigned char* dst_end);
void __cdecl asm_DecompressHFYU24To24DeltaDecorrelate(const unsigned long* src, unsigned char* dst, unsigned char* dst_end);
void __cdecl asm_DecompressHFYU24To32Delta(const unsigned long* src, unsigned char* dst, unsigned char* dst_end);
void __cdecl asm_DecompressHFYU24To32DeltaDecorrelate(const unsigned long* src, unsigned char* dst, unsigned char* dst_end);
void __cdecl asm_DecompressHFYU32To32Delta(const unsigned long* src, unsigned char* dst, unsigned char* dst_end);
void __cdecl asm_DecompressHFYU32To32DeltaDecorrelate(const unsigned long* src, unsigned char* dst, unsigned char* dst_end);

void __cdecl asm_SwapFields(unsigned char* buf, unsigned char* buf_end, int stride);

void __cdecl mmx_YUY2toRGB24(const unsigned char* src, unsigned char* dst, const unsigned char* src_end, int stride);
void __cdecl mmx_YUY2toRGB32(const unsigned char* src, unsigned char* dst, const unsigned char* src_end, int stride);
void __cdecl mmx_UYVYtoRGB24(const unsigned char* src, unsigned char* dst, const unsigned char* src_end, int stride);
void __cdecl mmx_UYVYtoRGB32(const unsigned char* src, unsigned char* dst, const unsigned char* src_end, int stride);

}
